org 100h
bits 16
cpu 8086

num_cols equ 16

section .text

start:
	mov bl, [080h] ; command-line arguments length
	and bl, bl
	jz exit
	xor bh, bh
	mov byte [081h + bx], 0
	; Now 082h is usable for filename (zero-terminated string)

	; Open file
	mov ah, 03dh
	mov al, 00 ; read only
	mov dx, 082h
	int 21h
	jc error
	mov [fhandle], ax

	; Reading
readchunk:
	mov ah, 03fh
	mov bx, [fhandle]
	mov cx, num_cols
	mov dx, readbuf
	int 21h ; n bytes read in ax

	; Display row
	mov bx, readbuf
	mov cx, ax
	and cx,cx
	jz no_more_data
	push ax ; Save n_bytes read
next_col:
	; Diplay hex byte
	mov dl, [bx]
	call printHexByte
	call printSpace

	inc bx
	dec cl
	jnz next_col

	call newline
	pop ax ; Restore n_bytes read
	cmp ax, num_cols
	je readchunk
no_more_data:
	; Partial read (less than num_cols) indicates
	; no more data. Newline and exit.
	call newline

	; Close the file
	mov ah, 03eh
	mov bx, [fhandle]
	int 21h

	jmp exit

error:
	mov ah, 09h
	mov dx, error_str
	int 21h

exit:
	mov ah,04CH
	mov al,00 ; Return 0
	int 21h

newline:
	push ax
	push dx
	mov ah,09h
	mov dx, nl_str
	int 21h
	pop dx
	pop ax
	ret

printSpace:
	push ax
	push dx
	mov ah,02h
	mov dl, ' '
	int 21h
	pop dx
	pop ax
	ret

; ***** printHexByte
; Byte in dl
printHexByte:
	push dx
	;shr dl, 4 ; Not available on 8086
	shr dl, 1
	shr dl, 1
	shr dl, 1
	shr dl, 1
	call printHexNibble
	pop dx
	call printHexNibble
	ret


; ***** printhexnibble
; Argument : Value in DL
printHexNibble:
	push dx
	and dl, 0FH
	cmp dl, 9
	ja letters
	add dl, '0'
	call putchar
	pop dx
	ret
letters:
	add dl, 'A'-10
	call putchar
	pop dx
	ret

; ******* putchar ******
; Argument: Character in DL
; Return: None
putchar:
	push ax
	mov ah,02H
	int 21h
	pop ax
	ret


section .data

nl_str:	db 13,10,'$'
error_str: db 13,10,'Error!',13,10,'$'

section .bss

fhandle: resw 1
readbuf: resb num_cols
